
/* return a remote connection's host name, or NULL if it */
/* can't be looked up */

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

char   *
getremotename(s)
	int     s;		/* connected socket fd */
{
	struct hostent *host;
	struct sockaddr_in rs;
	int     rs_size = sizeof(rs);

	/* get address of remote user */
	if (getpeername(s, (struct sockaddr *) & rs, &rs_size) < 0) {
		perror("server: getpeername failed");
		return (NULL);
	}
	/* get hostname from table */
	if ((host = gethostbyaddr((char *) &rs.sin_addr.s_addr,
		    sizeof(rs.sin_addr.s_addr), AF_INET)) == 0)
		return (inet_ntoa(rs.sin_addr));
	else
		return (host->h_name);
}
