#include "server.h"
#include "externs.h"
#include "config.h"
#include "search.h"
#include <strings.h>

/* function prototypes */
extern	void sendperson(int, int, char *);
int     item_compare(struct item *, struct item *);
int	readtable();
char	*remainder(char *);
void	error(int);
void	dumptable(int);
#ifdef	BSEARCH_NEED
char	*bsearch();
#endif	/* BSEARCH_NEED */

int
nicklookup(forWhom, theNick)
	int     forWhom;
	char   *theNick;
{
	struct item *item_ptr, item;
	FILE   *TheList;
	int     retval;
	char    line[BUFSIZ];

	/* mdb("nicklookup entered"); */
	/* open the information file */

	if ((TheList = fopen(THELIST, "r")) == NULL) {
		perror("TheList");
		exit(1);
	}
	/* mdb("TheList is open"); */

	strcpy(item.nick, theNick);

	/* mdb("nickname is copied"); */
	/* mdb(item.nick); */

	item_ptr = (struct item *) bsearch((char *) (&item),
	    (char *) nicktable, numnicks,
	    sizeof(struct item), item_compare);

	/* mdb("have looked up name"); */
	/* mdb(item_ptr->nick); */

	if (item_ptr != NULL) {
		/* mdb("user's name was found"); */
		/* mdb(item_ptr->nick); */
		fseek(TheList, item_ptr->offset, 0);
		retval = 0;

		while (fgets(line, BUFSIZ, TheList) != NULL) {
			if (line[0] != '\n') {
				if (forWhom >= 0) {
					sendperson(NICKSERV, forWhom, line);
				}
			} else {
				break;
			}
		}
	} else {
		if (forWhom >= 0) {
			sprintf(mbuf, "not found: %s\n", item.nick);
			sendperson(NICKSERV, forWhom, mbuf);
		}
		retval = -1;
	}

	/* close and return */
	fclose(TheList);
	return retval;
}
/*
 * This routine compares two items based on an alphabetical ordering of the
 * nick field. case insensitive
 */
int
item_compare(item1, item2)
	struct item *item1, *item2;
{
	return strcasecmp(item1->nick, item2->nick);
}

int
readtable()
{
	char    NickName[12];
	long    Offset;
	char   *remainder();
	char    line[BUFSIZ];
	FILE   *TheIndex;
	int     i = -1;

	/* open the index file */
	if ((TheIndex = fopen(THEINDEX, "r")) == NULL) {
		perror("TheIndex");
		exit(1);
	}
	/* loop through the entries and process them */
	while (fgets(line, BUFSIZ, TheIndex) != NULL) {

		i++;

		line[strlen(line) - 1] = '\0';

		sscanf(line, "%ld %s", &Offset, NickName);

		strcpy(nicktable[i].nick, NickName);
		nicktable[i].offset = Offset;
	}


	/* close and return */
	fclose(TheIndex);
	return i + 1;
}

char   *
remainder(line)
	char   *line;
{
	static char buf[80];
	int     len;

	len = strlen(line);
	strncpy(buf, &(line[2]), len - 3);
	buf[len - 3] = '\0';
	return buf;
}

void
error(k)
	int     k;
{
	printf("Error %d occurred.\n", k);
}

void
dumptable(max)
	int     max;
{
	int     k;
	char	mbuf[256];

	for (k = 0; k < max; k++) {
		sprintf(mbuf, "%s %ld\n",
			nicktable[k].nick, nicktable[k].offset);
		mdb(mbuf);
	}
}

#ifdef BSEARCH_NEED
/*
 * Copyright (c) 1990 Regents of the University of California. All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms are permitted provided
 * that: (1) source distributions retain this entire copyright notice and
 * comment, and (2) distributions including binaries display the following
 * acknowledgement:  ``This product includes software developed by the
 * University of California, Berkeley and its contributors'' in the
 * documentation or other materials provided with the distribution and in all
 * advertising materials mentioning features or use of this software. Neither
 * the name of the University nor the names of its contributors may be used
 * to endorse or promote products derived from this software without specific
 * prior written permission. THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE.
 */

#if defined(LIBC_SCCS) && !defined(lint)
static char sccsid[] = "@(#)bsearch.c	5.3 (Berkeley) 5/17/90";
#endif				/* LIBC_SCCS and not lint */

/*
 * Perform a binary search.
 *
 * The code below is a bit sneaky.  After a comparison fails, we divide the work
 * in half by moving either left or right. If lim is odd, moving left simply
 * involves halving lim: e.g., when lim is 5 we look at item 2, so we change
 * lim to 2 so that we will look at items 0 & 1.  If lim is even, the same
 * applies.  If lim is odd, moving right again involes halving lim, this time
 * moving the base up one item past p: e.g., when lim is 5 we change base to
 * item 3 and make lim 2 so that we will look at items 3 and 4. If lim is
 * even, however, we have to shrink it by one before halving: e.g., when lim
 * is 4, we still looked at item 2, so we have to make lim 3, then halve,
 * obtaining 1, so that we will only look at item 3.
 */

char   *
bsearch(key, base0, nmemb, size, compar)
	register void *key;
	void   *base0;
	size_t  nmemb;
	register size_t size;
	register int (*compar) ();
{
	register char *base = base0;
	register int lim, cmp;
	register void *p;

	for (lim = nmemb; lim != 0; lim >>= 1) {
		p = base + (lim >> 1) * size;
		cmp = (*compar) (key, p);
		if (cmp == 0)
			return (p);
		if (cmp > 0) {	/* key > p: move right */
			base = (char *) p + size;
			lim--;
		}		/* else move left */
	}
	return (NULL);
}
#endif				/* sun || ultrix */
