/* Copyright (c) 1991 by John Atwood deVries II. */
/* For copying and distribution information, see the file COPYING. */

/* code for the automagical users */

#include "server.h"
#include "externs.h"
#include "lookup.h"
#include "../h/protocol.h"
#include "../h/version.h"
#include <strings.h>

/* function declarations */
extern int split(char *);
extern char *getword(char *);
extern int check_auth(int);
extern void senderror(int, char *);
extern int readtable();
extern char *get_tail(char *);
extern int nicklookup(int, char *);
extern void sendperson(int, int, char *);
extern int lookup(char *, char **);

/* basic dispatch routine */

void
autoCommand(n)
	int     n;
{
	char   *cp;
	int     which;
	int     ret;

	split(pp);

	cp = getword(fields[1]);

	which = lookup(cp, auto_table);

	switch (which) {
	case AUTO_RELOAD:
		/* Are they allowed to do this? */
		if (!check_auth(n)) {
			senderror(n, "You may not do this.");
		} else {
			numnicks = readtable();
		}
		break;
	case AUTO_WHO:
		cp = getword(get_tail(fields[1]));
		if (strlen(cp) < 1)
			sendperson(NICKSERV, n,
				"Usage: whois nickname");
		else
			ret = nicklookup(n, cp);
		break;
	case AUTO_REGISTER:
		sendperson(NICKSERV, n,
		    "Registration is not yet available.");
		break;
	case AUTO_CHPASS:
		sendperson(NICKSERV, n,
		    "Password changing is not yet available.");
		break;
	case AUTO_DELETE:
		sendperson(NICKSERV, n,
		    "Deletion of nicks is not yet available.");
		break;
	case AUTO_REAL:
		sendperson(NICKSERV, n,
		    "Adding a real name is not yet available.");
		break;
	case AUTO_EMAIL:
		sendperson(NICKSERV, n,
		    "Adding an email address is not yet available.");
		break;
	case AUTO_PHONE:
		sendperson(NICKSERV, n,
		    "Adding phone info is not yet available.");
		break;
	case AUTO_SNAIL:
		sendperson(NICKSERV, n,
		    "Adding snailmail info is not yet available.");
		break;
	case AUTO_TEXT:
		sendperson(NICKSERV, n,
		    "Adding text info is not yet available.");
		break;
	case AUTO_READ:
		sendperson(NICKSERV, n,
		    "Reading messages is not yet available");
		break;
	case AUTO_WRITE:
		cp = getword(get_tail(fields[1]));
		if (strlen(cp) < 1)
			sendperson(NICKSERV, n,
				"Usage: write nick message");
		else
			sendperson(NICKSERV, n,
			    "Writing messages is not yet available");
		break;
	case AUTO_SECURE:
		sendperson(NICKSERV, n,
		    "Securing nicks is not yet available");
		break;
	case AUTO_UNSECURE:
		sendperson(NICKSERV, n,
		    "Unsecuring nicks is not yet available");
		break;
	case AUTO_INFO:
		ret = nicklookup(n, "nickserve");
		break;
	case AUTO_HELP:
		sendperson(NICKSERV, n,
		    "whois <nick>               returns info if available");
		sendperson(NICKSERV, n,
		    "p <passwd>                 registers current user info");
		sendperson(NICKSERV, n,
		    "cp <old> <new>             change password");
		sendperson(NICKSERV, n,
		    "delete <password>          delete curent user info");
		sendperson(NICKSERV, n,
		    "rname <real>               sets your real name");
		sendperson(NICKSERV, n,
		    "email <email-addr>         sets your email address");
		sendperson(NICKSERV, n,
		    "phone <real name>          sets your phone number");
		sendperson(NICKSERV, n,
		    "addr <snail-addr>          sets your snailmail address");
		sendperson(NICKSERV, n,
		    "text <some-text>           sets your text");
		sendperson(NICKSERV, n,
		    "read                       read messages left for you");
		sendperson(NICKSERV, n,
		    "write <nick> <message>     leave messages for someone");
		sendperson(NICKSERV, n,
		    "secure                     requires you to always enter your password");
		sendperson(NICKSERV, n,
		    "nosecure                   authenticates with username/hostname pair");
		sendperson(NICKSERV, n,
		    "info                       gives more info on server");
		sendperson(NICKSERV, n,
		    "help                       lists this table");
		sendperson(NICKSERV, n,
		    "?                          shows usage");
		break;
	case AUTO_QUESTION:
		sendperson(NICKSERV, n,
		    "usage: /m server {whois | p | cp | delete | rname | email | phone | addr | text | read | write | secure | nosecure | info | help | ?}");
		break;
	case AUTO_SHUTTIME:
		sendperson(NICKSERV, n,
		    "\"Shuttime\" not supported.  sorry.");
		break;
	default:
		ret = nicklookup(n, cp);
		break;
	}
	u_tab[NICKSERV].t_recv = time(NULL);
}
