/* Copyright (c) 1991 by John Atwood deVries II. */
/* For copying and distribution information, see the file COPYING. */

/* handle a packet from the server */

#include "server.h"
#include "externs.h"

/* function declarations */
extern int loginmsg(int, char *);
extern void sendexit(int);
extern void openmsg(int, char *);
extern void senderror(int, char *);
extern void cmdmsg(int, char *);
extern void pong(int, char *);
extern void mdb(char *);


void
dispatch(n, pkt)
	int     n;		/* socket on which the message arrived */
	char   *pkt;		/* packet buffer */
{
	switch (*pkt) {

	case M_LOGIN:
		if (loginmsg(n, ++pkt) < 0) {
			/* login failed.  dump them */
			sendexit(n);
		}
		break;

/*
	this case duplicates the login case label, and so is omitted.

	case M_LOGINOK:
		senderror(n, "Server doesn't handle M_LOGINOK packets");
		break;
*/

	case M_OPEN:
		openmsg(n, ++pkt);
		break;

	case M_PERSONAL:
		senderror(n, "Server doesn't handle M_PERSONAL packets");
		break;

	case M_STATUS:
		senderror(n, "Server doesn't handle M_STATUS packets");
		break;

	case M_ERROR:
		senderror(n, "Server doesn't handle M_ERROR packets");
		break;

	case M_IMPORTANT:
		senderror(n, "Server doesn't handle M_IMPORTANT packets");
		break;

	case M_EXIT:
		senderror(n, "Server doesn't handle M_EXIT packets");
		break;

	case M_COMMAND:
		cmdmsg(n, ++pkt);
		break;

	case M_CMDOUT:
		senderror(n, "Server doesn't handle M_CMDOUT packets");
		break;

	case M_PROTO:
		senderror(n, "Server doesn't handle M_PROTO packets");
		break;

	case M_BEEP:
		senderror(n, "Server doesn't handle M_BEEP packets");
		break;

	case M_PING:
		senderror(n, "Server doesn't handle M_PING packets");
		break;

	case M_PONG:
		senderror(n, "Server doesn't handle M_PONG packets");
/*		pong(n, pkt); */
		break;

	default:
		sprintf(mbuf, "[Error] Invalid packet type \"%c\"", *pkt);
		senderror(n, mbuf);
		mdb(mbuf);
	}
}
