/* Copyright (c) 1991 by John Atwood deVries II. */
/* For copying and distribution information, see the file COPYING. */

/* "icb" global variables */

#include "server.h"
#include "config.h"
#include "groups.h"
#include "users.h"
#include "ipcf.h"

/* non-global definitions */
char    packetbuffer[USER_BUF_SIZE];	/* packet buffer */
char    messagebuffer[1024];	/* generic large buffer */
char    messagebuffer2[256];	/* generic large buffer */

/* global defs */
char   *pp = packetbuffer;	/* packet pointer */
char   *pbuf = packetbuffer + 1;/* packet buffer pointer */
char   *mbuf = messagebuffer;	/* message buffer */
char   *mbuf2 = messagebuffer2;	/* message buffer */
char    thishost[MAXHOSTNAMELEN];	/* our hostname */
time_t  curtime;		/* current time */
char    MyString[80];
int     S_kill = 0;		/* don't need to kill anyone, yet */
int	debug = 0;		/* debug flag */
char	*program = NULL;	/* what name we were invoked with */

/* lookup tables */

/* commands */
char   *command_table[] =
{
	"drop",
	"shutdown",
	"wall",
	"beep",
	"cancel",
	"g",
	"invite",
	"pass",
	"boot",
	"status",
	"topic",
	"motd",
	"m",
	"echoback",
	"name",
	"v",
	"w",
	"info",
	(char *) 0
};

char   *status_table[] =
{
	"r",			/* restricted */
	"m",			/* moderated */
	"p",			/* public */
	"i",			/* invisible */
	"s",			/* secret */
	"v",			/* visible */
	"q",			/* quiet */
	"n",			/* normal */
	"l",			/* loud */
	"name",			/* name of the group */
	"?",			/* list this table */
	(char *) 0
};

char   *auto_table[] =
{
	/* nickname == admin, password == TheKey */
	"reload",		/* reload index from file */
	"whois",		/* whois (lookup) */
	"p",			/* register(loginid,nodeid,nickname,password)*/
	"cp",			/* change pass (old, new) */
	"delete",		/* delete nick */
	"rname",		/* set or change real name */
	"email",		/* email address */
	"phone",		/* phone number */
	"addr",			/* snailmail address */
	"text",			/* text */
	"read",			/* read messages */
	"write",		/* write messages */
	"secure",		/* everyone must get stoned */
	"unsecure",		/* auth by user/host pair */
	"info",			/* information on this service */
	"help",			/* help for use of the service */
	"?",			/* list this table */
	"shuttime",		/* not supported */
	(char *) 0
};
/* the world */
USER_ITEM u_tab[MAX_USERS];	/* that many users possible */
GROUP_ITEM g_tab[MAX_GROUPS];	/* only one group for now */
struct item nicktable[TABSIZE];	/* nickname table to be searched */
int     numnicks;		/* number of nicknames that are registered */

/* flags set in .icbdrc */
int     m_whoheader = 1;	/* who header output */
int     m_groupheader = 1;	/* group header output */
int     m_nomesg = 0;		/* turn off messages while in icbd */
int     m_watchtime = 0;	/* using boring time format */

TTYINFO ttyinfo;

GLOBS   gv = {
	ICBDLOG,		/* logfile */
	"normal",		/* timedisplay */
};
