/* Copyright 1991 by John Atwood deVries II. */
/* For copying and distribution information, see the file COPYING. */

/* primitives to deal with admin commands */

#include <string.h>
#include "server.h"
#include "externs.h"

/* function declarations */
extern void senderror(int, char *);
extern int find_user(char *);
extern char *getword(char *);
extern void disconnectuser(int);
extern void mdb(char *);
extern void icbexit();
extern void sendimport(int, char *, char *);
int     check_auth(int);


int
s_drop(n, argc)
	int     n;
	int     argc;
{
	int     TheVictim;

	/* before we even look at what they sent us, are the allowed? */
	if (!check_auth(n)) {
		senderror(n, "You are not authorized to do this.");
		return (-1);
	}
	if (argc == 2) {
		/* fields[1] can be a string, not just a single nick */
/*		mdb(getword(fields[1]));    who to drop */
/*		mdb(get_tail(fields[1]));    why they are being dropped?? */
		TheVictim = find_user(getword(fields[1]));
		if (TheVictim < 0) {
			senderror(n, "That person isn't on");
		} else {
			disconnectuser(TheVictim);
			/* BUG tell other folx about it... wall? tell the user
			 * about it? */
		}
	} else {
		mdb("drop: wrong number of parz");
	}
	return 0;
}

int
s_shutdown(n, argc)
	int     n;
	int     argc;
{
	int t;
	/* before we even look at what they sent us, are the allowed? */
	if (!check_auth(n)) {
		senderror(n, "You are not authorized to do this.");
		return (-1);
	}
	if (argc == 2) {
		/* fields[1] is when and comments, separated by a blank */
/*		mdb(getword(fields[1])); */
/*		mdb(get_tail(fields[1]));  why we are shutting down*/
		/* BUG	we are presuming when is always now. ...but then, I
		 * don't know how to schedule anything anyhow. we are
		 * presuming that no warning is given */
		for (t = 0; t < MAX_REAL_USERS; t++)
			if (u_tab[t].login == 1)
				sendimport(t, "SHUTDOWN",
					"Server is shutting down");
		icbexit();
	} else {
		mdb("shutdown: wrong number of parz");
	}
	return 0;
}

int
s_wall(n, argc)
	int     n;
	int     argc;
{
	int     user;

	/* before we even look at what they sent us, are the allowed? */
	if (!check_auth(n)) {
		senderror(n, "You are not authorized to do this.");
		return (-1);
	}
	if (argc == 2) {
/*		mdb(fields[1]);  text of message */
		/* send it only to the real users */
		for (user = 0; user < MAX_REAL_USERS; user++) {
			if (u_tab[user].login == 1) {
				sendimport(user, "WALL", fields[1]);
			}
		}
	} else {
		mdb("wall: wrong number of parz");
	}
	return 0;
}

int
check_auth(n)
	int     n;
{
	int     auth = 0;

	mdb("checking authorization");
	mdb(u_tab[n].nickname);
	mdb(u_tab[n].password);
	if (strcasecmp(u_tab[n].nickname, "ADMIN") == 0)
		auth++;
	if (strcasecmp(u_tab[n].password, TheKey) == 0)
		auth++;
	return (auth == 2);
}
