/* Copyright 1991 by John Atwood deVries II. */
/* For copying and distribution information, see the file COPYING. */

/* primitive to change user info */

#include "server.h"
#include "externs.h"
#include <strings.h>

/* function prototypes */
extern int find_user(char *);
extern void senderror(int, char *);
extern void filternickname(char *);
extern void s_status_group(int, int, int, char *, char *);
extern void sendstatus(int, char *, char *);
extern int nicklookup(int, char *);
extern void mdb(char *);

int
s_name(n, argc)
	int     n;
	int     argc;
{
	int     len;
	int     how_many;
	char    new_name[MAX_NICKLEN + 1];
	int     ret;

	if (argc == 2) {
		/* constraints: will only use the first max_nicklen letters of
		 * a nickname. nickname must be at least 1 character long. to
		 * use the nickname admin, must have password set to TheKey */

		/* make sure the nickname hasn't already been taken */

		if (find_user(fields[1]) >= 0) {
			/* oops, someone already has this nick */
			senderror(n, "Nickname already in use.");
			return (-1);
		}
		/* only use so much of it, but at least some of it */
		len = strlen(fields[1]);
		if (len <= 0) {
			/* oops, too short */
			senderror(n, "The nickname may not be null.");
			return (-1);
		}
		how_many = (MAX_NICKLEN > len) ? len : MAX_NICKLEN;
		bzero(new_name, MAX_NICKLEN + 1);
		strncpy(new_name, fields[1], how_many);
		filternickname(new_name);

		/* make sure they are allowed to use this nickname */
		if (strcasecmp(new_name, "admin") == 0) {
			if (strcasecmp(u_tab[n].password, TheKey) != 0) {
				/* oops, password is wrong */
				senderror(n, "Nickname already in use.");
				return (-1);
			}
		}
		sprintf(mbuf, "%s changed nickname to %s",
		    u_tab[n].nickname, new_name);
		s_status_group(1, 0, n, "Name", mbuf);

		strcpy(u_tab[n].nickname, new_name);



		/* side-effects: inform folx in same group of change if they
		 * are registered, set their real name. */
		sendstatus(n, "Nickname", mbuf);

		/* check to see if we know this person */
/*		mdb(" about to do nicklookup"); */
/*		mdb(u_tab[n].nickname); */
		ret = nicklookup(-1, u_tab[n].nickname);
		if (ret == 0) {
			/* we know this person */
			strcpy(u_tab[n].realname, "registered");
/*			mdb("person is known"); */
		} else {
			/* we don't know this person */
			bzero(u_tab[n].realname, MAX_REALLEN + 1);
/*			mdb("person is unknown"); */
		}
/*		mdb("finished checking on person"); */
	} else {
		mdb("name: wrong number of parz");
	}
	return 0;
}

void
s_echoback(n, argc)
	int     n;
	int     argc;
{
	if (argc == 2) {
		if (strcasecmp(fields[1], "off") == 0) {
			u_tab[n].echoback = 0;	/* off */
			sendstatus(n, "Echoback", "now off");
		} else
			if (strcasecmp(fields[1], "on") == 0) {
				u_tab[n].echoback = 1;	/* on */
				sendstatus(n, "Echoback", "now on");
			} else {
				senderror(n, "Echoback: needs on/off");
			}
	} else {
		mdb("echoback: wrong number of parz");
	}
}
