/* Copyright 1991 by John Atwood deVries II. */
/* For copying and distribution information, see the file COPYING. */

/* primitive to list users */

#include "server.h"
#include "externs.h"
#include <strings.h>

#define DOGROUPONLY	1
#define DOSHORT		2
#define MAX_LINE	75

/* function declarations */
extern void mdb(char *);
extern char *getword(char *);
extern char *get_tail(char *);
extern int find_user(char *);
extern void senderror(int, char *);
extern int find_group(char *);
extern int nlpresent(char *, NAMLIST *);
extern void sends_cmdout(int, char *);
extern void user_whead(int);
extern void 
user_wline(int, char *, char *, int, int, int,
    char *, char *, char *);
void    doAll(int, int);
void    doOne(int, int, char *, int);
void    print_group_header(int, int);
void    print_group_members(int, int, int);
void    print_totals(int, int, int);
void    pgm_short(int, int);
void    pgm_long(int, int);
void    add_item(int, char *, char *);

int
s_who(n, argc)
	int     n;
	int     argc;
{
	int     len;
	int     how_many;
	int     flags;
	int     target_user;
	char    tgrp[MAX_GROUPLEN + 1];
	char   *cp;

/*	mdb("entered s_who"); */

	if (argc == 2) {

/*	mdb("good # of args"); */

		/* fields[0] was "w" */
		/* fields[1] is a string indicating the kind of who */

		/* handle the flags (if any) */
		cp = getword(fields[1]);
/*	mdb("first word is"); */
/*	mdb(cp); */
		if (strcasecmp(cp, "-g") == 0) {
			flags = DOGROUPONLY;
/*	mdb("do group only"); */
		} else
			if (strcasecmp(cp, "-s") == 0) {
				flags = DOSHORT;
/*	mdb("do long"); */
			} else
				if (strcasecmp(cp, "?") == 0) {
					sends_cmdout(n, "usage: /w {-g | -s} {groupname}");
/*	mdb("do question"); */
					return 0;
				} else {
					flags = 0;
/*	mdb("no flags"); */
				}

		/* use fields[1] if no flag otherwise use get_tail(fields[1]) */
		if (flags == 0) {
			len = strlen(getword(fields[1]));
/*	printf("length of first word is %d\n",len); */
		} else {
			len = strlen(getword(get_tail(fields[1])));
/*	printf("length of first word of tail is %d\n",len); */
		}

		how_many = (MAX_GROUPLEN > len) ? len : MAX_GROUPLEN;
		bzero(tgrp, MAX_GROUPLEN + 1);

		if (flags == 0) {
			strncpy(tgrp, getword(fields[1]), how_many);
/*	mdb("tgrp (word) is"); */
/*	mdb(tgrp); */
		} else {
			strncpy(tgrp, getword(get_tail(fields[1])),
			    how_many);
/*	mdb("tgrp (word(tail)) is"); */
/*	mdb(tgrp); */
		}

		if (len == 0) {
			/* of all groups */
/*	mdb("all groups"); */
			doAll(n, flags);
		} else {
			/* on some particular group */
			if (fields[1][0] == '@')
				if ((target_user = find_user(&fields[1][1])) < 0) {
					senderror(n, "User not found or is in an invisible group.");
					return -1;
				} else
					if (g_tab[find_group(u_tab[target_user].group)].visibility == INVISIBLE) {
						senderror(n, "User not found or is in an invisible group.");
						return -1;
					} else
						strcpy(tgrp, u_tab[target_user].group);

			if (strcmp(tgrp, ".") == 0) {
				/* n's group */
				strcpy(tgrp, u_tab[n].group);
/*	mdb("substitute n's group"); */
			}
/*	mdb("one particular group"); */
			doOne(n, flags, tgrp, 1);
		}
	} else {
/*		mdb("who: wrong number of parz"); */
	}
	return 0;
}

void
doAll(n, flags)
	int     n;
	int     flags;
{
	int     group;
	int     my_group;
	int     is_invited;
	int     total_group = 0, total_users = 0;

	my_group = find_group(u_tab[n].group);

	for (group = 0; group < MAX_GROUPS; group++) {
		is_invited = nlpresent(u_tab[n].nickname, g_tab[group].invites);
		if (strlen(g_tab[group].name) != 0) {
			total_group++;
			total_users += g_tab[group].num_users;
			if ((g_tab[group].visibility != INVISIBLE) ||
			    is_invited || (group == my_group)) {
				doOne(n, flags, g_tab[group].name, 0);
			}
		}
	}
	print_totals(n, total_group, total_users);
}

void
doOne(n, flags, tgrp, how)
	int     n;
	int     flags;
	char   *tgrp;
	int     how;
{
	int     which;

	which = find_group(tgrp);

	if (which >= 0) {
		/* the group exists */
		/* how says whether to print the header or not */
/*		if (how)
			print_group_title(n); */
		print_group_header(n, which);
		print_group_members(n, which, flags);
	} else {
		/* the group doesn't exist */
		bzero(mbuf, 80);
		sprintf(mbuf, "The group %s doesn't exist.", tgrp);
		senderror(n, mbuf);
	}
}

void
print_group_header(n, grp)
	int     n;
	int     grp;
{
	char    GroupName[MAX_GROUPLEN + 1];
	char    TheMod[MAX_NICKLEN + 1];
	int     mod;
	char    TheTopic[MAX_TOPICLEN + 1];
	char    Options[20];
	int     isMyGroup;
	int     is_invited;
	static char *ctl[] = {"*", "p", "m", "r"};
	static char *vis[] = {"*", "v", "s", "i"};
	static char *vol[] = {"*", "q", "n", "l"};
/* XXX old
	static char *ctl[] = {"*", "Public", "Mod.", "Restr."};
	static char *vol[] = {"*", "Quiet", "Normal", "Loud"};
*/

	bzero(TheMod, MAX_NICKLEN + 1);
	mod = g_tab[grp].mod;
	if (mod < 0) {
		strcpy(TheMod, "(None)");
	} else {
		strcpy(TheMod, u_tab[mod].nickname);
	}

	bzero(TheTopic, MAX_TOPICLEN + 1);
	if (strlen(g_tab[grp].topic) == 0) {
		strcpy(TheTopic, "(None)");
	} else {
		strcpy(TheTopic, g_tab[grp].topic);
	}

	bzero(Options, 10);
	sprintf(Options, "(%s%s%s)",
	    ctl[g_tab[grp].control],
	    vis[g_tab[grp].visibility],
	    vol[g_tab[grp].volume]);

	isMyGroup = (find_group(u_tab[n].group) == grp);
	bzero(GroupName, MAX_GROUPLEN + 1);
	is_invited = nlpresent(u_tab[n].nickname, g_tab[grp].invites);
	if ((g_tab[grp].visibility == SECRET) ||
	    (g_tab[grp].visibility == INVISIBLE))
		if (!isMyGroup && !is_invited)
			strcpy(GroupName, "-SECRET-");
		else {
			strcpy(GroupName, "*");
			strcat(GroupName, g_tab[grp].name);
			strcat(GroupName, "*");
		}
	else {
		strcpy(GroupName, g_tab[grp].name);
		strcat(GroupName, "  ");
	}

	bzero(mbuf, 80);
	sends_cmdout(n, mbuf);	/* a blank line */
	sprintf(mbuf, "Group: %-8s %s Mod: %-12s  Topic: %s",
	    GroupName,
	    Options,
	    TheMod,
	    TheTopic);
	sends_cmdout(n, mbuf);
}

void
print_group_members(n, which, flags)
	int     n;
	int     which;
	int     flags;
{
	if (flags & DOGROUPONLY) {
		/* don't print users */
	} else {
		if (flags & DOSHORT) {
			pgm_short(n, which);
		} else {
			pgm_long(n, which);
		}
	}
}

void
pgm_long(n, which)
	int     n;
	int     which;
{
	int     user;
	int     Idle;
	time_t  TheTime;
	int     gpmod;
	int     num_users;
	char    cp[5];
	char   *reg;


	TheTime = time(NULL);

	num_users = g_tab[which].num_users;
	if (num_users >= 2)	/* bweh! */
		user_whead(n);
	for (user = 0; user < MAX_USERS; user++) {
		/* are they in this group? */
		if (which == find_group(u_tab[user].group)) {

			Idle = TheTime - u_tab[user].t_recv;

			gpmod = (g_tab[which].mod == user);
			if (gpmod) {
				strcpy(cp, "m");
			} else {
				strcpy(cp, " ");
			}

			if (strlen(u_tab[user].realname) == 0) {
				reg = "(nr)";
			} else {
				reg = "";
			}

			user_wline(n, cp, u_tab[user].nickname, Idle, 0,
			    u_tab[user].t_on,
			    u_tab[user].loginid,
			    u_tab[user].nodeid,
			    reg);
		}
	}
}

void
pgm_short(n, which)
	int     n;
	int     which;
{
	int     user;
	int     num_users;
	char    line[MAX_LINE];

	num_users = g_tab[which].num_users;
	bzero(line, MAX_LINE);

	add_item(n, "members: ", line);

	for (user = 0; user < MAX_USERS; user++) {
		/* are they in this group? */
		if (which == find_group(u_tab[user].group)) {
			add_item(n, u_tab[user].nickname, line);
			num_users--;
			if (num_users != 0) {
				add_item(n, ", ", line);
			}
		}
	}
	/* flush last line if any */
	if (strlen(line) != 0) {
		sends_cmdout(n, line);
	}
}

void
add_item(n, item, buf)
	int     n;
	char   *item;
	char   *buf;
{
	if ((strlen(item) + strlen(buf) + 1) >= MAX_LINE) {
		sends_cmdout(n, buf);
		bzero(buf, MAX_LINE);
		/* do NOT put comma at the beginning of the line */
		if (strcmp(item, ", ") != 0) {
			strcpy(buf, item);
		}
	} else {
		strcat(buf, item);
	}
}

void
print_totals(n, groups, users)
	int     n, groups, users;
{
	sprintf(mbuf, "Total: %d users in %d groups", users, groups);
	sends_cmdout(n, mbuf);
}
