/* Copyright (c) 1991 by John Atwood deVries II. */
/* For copying and distribution information, see the file COPYING. */

#include "../h/protocol.h"
#include <stdio.h>

#ifndef ICB_UID
# define ICB_UID	32765
#endif
#ifndef ICB_GID
# define ICB_GID	32765
#endif

/*
   BEWARE!! of the relationship between MAX_REAL_USERS and the various
   resident automagical users -- esp. for fencepost errors.
*/
#define	MAX_REAL_USERS (MAX_USERS - 1)
#define	NICKSERV (MAX_USERS - 1)

/* number of folx who can be registered with NickServe */
#define	TABSIZE   200

/* The Master Password -- need this in loginmsg to be admin */
/* see also s_user.c and s_admin.c about this. */
#define	TheKey	"Freepish"


/* special global variables */

typedef struct {
	char   *logfile;	/* name of session log file */
	char   *timedisplay;	/* how time is displayed */
}       GLOBS;
/* a linked list of strings */

typedef struct Strlist {
	struct Strlist *next, *prev;
	char    str[1];
}       STRLIST;
/* manages a name list */
typedef struct Namlist {
	STRLIST *head, *tail;	/* head and tail of name list */
	STRLIST *p;		/* user current location in name list */
	int     num;		/* current number of name list entries */
	int     max;		/* max number of list entries before discard */
}       NAMLIST;

typedef struct {
	char    loginid[MAX_IDLEN + 1];	/* their loginid */
	char    nodeid[MAX_NODELEN + 1];	/* the id of their client's
						 * machine */
	char    nickname[MAX_NICKLEN + 1];	/* their nickname */
	char    password[MAX_PASSWDLEN + 1];	/* their password */
	char    realname[MAX_REALLEN + 1];	/* their real name */
	char    group[MAX_GROUPLEN + 1];	/* name of which group they
						 * are in */
	int     login;		/* have they sent a login message yet */
	int     echoback;	/* do they have echoback on or off? */
	int	flags;		/* server flags (e.g. idled out) */
	time_t  t_on;		/* when signed on, */
	time_t  t_sent;		/* last time we sent them something */
	time_t  t_recv;		/* last time they sent us something -- */
	/* all time stuff */
}       USER_ITEM;

typedef struct {
	char    name[MAX_GROUPLEN + 1];	/* the name of the group */
	/* if inactive, then NULL */
	char    topic[MAX_TOPICLEN + 1];	/* the topic of that group */
	/* if inactive, then NULL */
	int	num_users;	/* number of people in it */
	int     visibility;	/* NORMAL, SECRET, INVISIBLE */
	int     control;	/* PUBLIC, MODERATED, RESTRICTED */
	int     mod;		/* index of who is moderator (if any) */
	/* if none, then -1 */
	int     volume;		/* quiet, normal, loud */
	NAMLIST *invites;
	/* next group  (if it was a linked list instead of a table) */
}       GROUP_ITEM;
/* these are stored in the table */
struct item {
	char    nick[12];
	long    offset;
};
/* info on the user's tty */

typedef struct {
	char    erase;		/* tty erase char */
	char    kill;		/* tty kill char */
	char    redraw;		/* tty reprint line char */
	char    werase;		/* tty word erase char */
	int     rows;		/* tty word erase char */
	int     cols;		/* tty word erase char */
}       TTYINFO;


/* misc */

#define CMDCHAR		'/'	/* default char for prefixing commands */
#define PERMCMDCHAR	'\\'	/* like above, but can't be changed */

/* putline flags */

#define PL_SCR		01	/* text may go to screen */
#define PL_LOG		02	/* text may go to session log */
#define PL_BUF		04	/* text may go to review buffer */
#define PL_SL		(PL_SCR|PL_LOG)
#define PL_ALL		(PL_SCR|PL_LOG|PL_BUF)

/* include function prototypes if ANSI compiler */
/* otherwise, include file that shows return type for each function */
