/* Copyright (c) 1991 by John Atwood deVries II. */
/* For copying and distribution information, see the file COPYING. */

/* signal handling routines */

#include "server.h"
#include "externs.h"
#include <signal.h>
#include <unistd.h>

/* The signal stuff is not portable, and should be in unix.c. */

#define	mask(s)	(1 << ((s)-1))

/* set up the signal trappers */

void    askquit();
extern void icbexit();

void
trapsignals()
{
	/* exit on a hangup or terminate signal */
	signal(SIGHUP, icbexit);
	signal(SIGTERM, icbexit);

	/* on an interrupt, verify the user wants to quit */
	signal(SIGINT, askquit);
}


/* verify that the user wants to quit */

void
askquit()
{
	int     c;
	static char out[3] = {'\0', '\r', '\n'};

	signal(SIGINT, SIG_IGN);
	write(1, "\rReally Quit? ", 14);
	if ((c = getchar()) == EOF)
		icbexit();
	else {
		out[0] = c;
		write(1, out, 3);
		if (c == 'Y' || c == 'y')
			icbexit();
		else {
			signal(SIGINT, askquit);
		}
	}
}
