#include <stdio.h>
#include <search.h>
#include <strings.h>

#define   TABSIZE   512

/* these are stored in the table */
struct item {
	char nick[12];
	long offset;
};

	struct item table[TABSIZE];   /* table to be searched */

main()
{
	struct item *item_ptr, item;
	int item_compare( );  /* routine to compare 2 items */
	FILE *TheList;
	int count;
	char line[BUFSIZ];

	count = readtable();
	dumptable(count);

	/* open the information file */
	if((TheList = fopen("TheList", "r")) == NULL) {
		perror("TheList");
		exit(1);
	}
	printf("TheList opened\n");

	while (scanf("%s", item.nick) != EOF) {
		item_ptr = (struct item *)bsearch((char *)(&item),
			   (char *)table, count,
			   sizeof(struct item), item_compare);
		if (item_ptr != NULL) {
			(void)printf("nick = %20s, offset = %ld\n",
				     item_ptr->nick, item_ptr->offset);

			fseek(TheList, item_ptr->offset, 0);
			while (fgets(line, BUFSIZ, TheList) != NULL) {
				if (line[0] != '\n') 
					printf("%s", line);
				else
					break;
			}
		} else {
			(void)printf("not found: %s\n", item.nick);
		}
	}
	/* close and quit */
	fclose(TheList);
}

/*
	This routine compares two items based on an
	alphabetical ordering of the nick field.
	case insensitive
*/
int
item_compare(item1, item2)
struct item *item1, *item2;
{
	return strcasecmp(item1->nick, item2->nick);
}

int
readtable()
{
	char NickName[12];
	long Offset;
	char * remainder();
	char line[BUFSIZ];
	FILE *TheIndex;
	int i = -1;

	/* open the index file */
	if((TheIndex = fopen("TheIndex.srt", "r")) == NULL) {
		perror("TheIndex");
		exit(1);
	}

	/* loop through the entries and process them */
	while (fgets(line, BUFSIZ, TheIndex) != NULL) {

		i++;

		line[strlen(line) - 1] = '\0';

		sscanf(line, "%ld %s", &Offset, NickName);

		strcpy(table[i].nick, NickName);
		table[i].offset =Offset;
	}


	/* close and return */
	fclose(TheIndex);
	return i+1;
}

char * remainder(line)
char * line;
{
	static char buf[80];
	int len;

	len = strlen(line);
	strncpy(buf, &(line[2]), len - 3);
	buf[len - 3] = '\0';
	return buf;
}

error(k)
int k;
{
	printf("Error %d occurred.\n", k);
}

dumptable(max)
int max;
{
	int k;

	for(k=0; k<max; k++) {
		printf("%s %ld\n", table[k].nick, table[k].offset);
	}
}
