#include <stdio.h>
#include <strings.h>

	int NumberOfRealNames=0;
	int NumberOfNickNames=0;
	int NumberOfEmail=0;
	int NumberOfSnail=0;
	int NumberOfPhone=0;
	long where;
	long oldwhere=0;
	char RealName[80];
	char NickName[160];
	char FirstNick[40];
	char Email[160];
	char Snail[320];
	char Phone[80];
	char * remainder();
	char line[BUFSIZ];
	FILE *TheList;
	FILE *TheIndex;

main (argc,argv)
int argc;
char ** argv;
{
	int state=0;
	char * cp;

	if (argc != 2) {
		printf("Usage: %s listfile\n", argv[0]);
		exit(1);
	}

	/* open the information file */
	if((TheList = fopen(argv[1], "r")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	/* open the index file */
	if((TheIndex = fopen("TheIndex", "w")) == NULL) {
		perror("TheIndex");
		exit(1);
	}

	bzero(RealName, 80);
	zap();

	/* loop through the entries and process them */
	do {
		where = ftell(TheList);
		cp = fgets(line, BUFSIZ, TheList);

		if (cp != NULL) {
			switch(line[0]) {
			case 'R':
				state = RealInput(state);
				break;
			case 'N':
				state = NickInput(state);
				break;
			case 'E':
				state = EmailInput(state);
				break;
			case 'A':
				state = SnailInput(state);
				break;
			case 'P':
				state = PhoneInput(state);
				break;
			case '#':
				/* comment */
			case ' ':
			case '\t':
			case '\n':
				/* blank line */
				break;
			case 'W':
				printf("Password\n");
				break;
			default:
				printf("Item not understood\n");
				printf("%s", line);
			}
		}
	}
	while (cp != NULL);

	/* handle the last entry */
	dumpPrevious();

	/* say something about the file */
	printf("There were %d real names.\n",NumberOfRealNames);
	printf("There were %d nicknames.\n",NumberOfNickNames);
	printf("There were %d email addresses.\n",NumberOfEmail);
	printf("There were %d snailmail address lines.\n",NumberOfSnail);
	printf("There were %d phone numbers.\n",NumberOfPhone);

	/* close and quit */
	fclose(TheList);
	fclose(TheIndex);
	exit(0);
}

char * remainder(line)
char * line;
{
	static char buf[80];
	int len;

	len = strlen(line);
	strncpy(buf, &(line[2]), len - 3);
	buf[len - 3] = '\0';
	return buf;
}

RealInput(n)
int n;
{
	switch(n){
	case 0:
		doReal();
		return 1;
	case 1:
		error(5);
		return 0;
	case 2:
		doReal();
		return 1;
	case 3:
		doReal();
		return 1;
	case 4:
		doReal();
		return 1;
	default:
		error(14);
		return 0;
	}
}

doReal()
{
	dumpPrevious();
	NumberOfRealNames++;
	strcpy(RealName, remainder(line));
	oldwhere = where;
}

NickInput(n)
int n;
{
        switch(n){
        case 0:
                error(1);
                return 0;
        case 1:
                doNick();
                return 1;
        case 2:
		error(8);
                return 0;
        case 3:
		error(9);
                return 0;
        case 4:
		error(11);
                return 0;
        default:
                error(15);
                return 0;
        }
}

doNick()
{
	NumberOfNickNames++;
	tack(NickName, remainder(line));
	if(strlen(FirstNick) == 0) {
		strcpy(FirstNick, remainder(line));
	}
}

EmailInput(n)
int n;
{
        switch(n){
        case 0:
		error(2);
                return 0;
        case 1:
                doEmail();
                return 2;
        case 2:
                doEmail();
                return 2;
        case 3:
                error(10);
                return 0;
        case 4:
                error(12);
                return 0;
        default:
                error(16);
                return 0;
        }
}

doEmail()
{
	NumberOfEmail++;
	tack(Email, remainder(line));
}

SnailInput(n)
int n;
{
        switch(n){
        case 0:
		error(3);
                return 0;
        case 1:
                doSnail();
                return 3;
        case 2:
                doSnail();
                return 3;
        case 3:
                doSnail();
                return 3;
        case 4:
                error(13);
                return 0;
        default:
                error(17);
                return 0;
        }
}

doSnail()
{
	NumberOfSnail++;
	tack(Snail, remainder(line));
}


PhoneInput(n)
int n;
{
        switch(n){
        case 0:
                error(4);
                return 0;
        case 1:
                doPhone();
                return 4;
        case 2:
                doPhone();
                return 4;
        case 3:
                doPhone();
                return 4;
        case 4:
                doPhone();
                return 4;
        default:
                error(18);
                return 0;
        }
}

doPhone()
{
	NumberOfPhone++;
	tack(Phone, remainder(line));
}

error(k)
int k;
{
	printf("Error %d occurred.\n", k);
}

zap()
{
	bzero(NickName, 160);
	bzero(FirstNick, 40);
	bzero(Email, 160);
	bzero(Snail, 320);
	bzero(Phone, 80);
}

dumpPrevious()
{
	if(strlen(RealName) == 0) {
		printf("real name was null\n");
	} else {
		/* do dumping stuff */
		fprintf(TheIndex, "%ld %s\n", oldwhere, FirstNick);
		printf("%s\n", RealName);
		/*
		printf("%s %ld\n", FirstNick, oldwhere);

		if(strlen(NickName) != 0) {
			printf("%s\n", NickName);
		} else {
			printf(":none\n");
		}

		if(strlen(Email) != 0) {
			printf("%s\n", Email);
		} else {
			printf(":none\n");
		}

		if(strlen(Snail) != 0) {
			printf("%s\n", Snail);
		} else {
			printf(":none\n");
		}

		if(strlen(Phone) != 0) {
			printf("%s\n", Phone);
		} else {
			printf(":none\n");
		}
		*/

		/* clear things again */
		zap();
	}
}

tack(dest, delta)
char * dest;
char * delta;
{
	strcat(dest, ":");
	strcat(dest, delta);
}
