/* Copyright (c) 1991 by John Atwood deVries II. */
/* For copying and distribution information, see the file COPYING. */

#include "server.h"
#include "externs.h"
#include <sys/time.h>
#include <stdlib.h>

/* return a string indicating idle time */

char   *
idlestr(num)
	char   *num;
{
	int     seconds = atoi(num);
	static char idletime[8];

	if (seconds >= 60) {
		sprintf(idletime, "%2dm", seconds / 60);
		return (idletime);
	} else
		return ("  -");
}


/* return a string indicating response time */

char   *
response(num)
	char   *num;
{
	int     secs = atoi(num);
	static char rtime[8];

	if (secs >= 2) {
		sprintf(rtime, " %2ds", secs);
		return (rtime);
	} else
		return ("   -");
}
/* return a time, i.e "7:45pm" */


char   *
ampm(secs, style)
	time_t  secs;
	int     style;
{
	struct tm *t, *localtime();
	static char timestr[12];
	int     hr, mn;

	t = localtime(&secs);
	hr = t->tm_hour;
	mn = t->tm_min;

	if (style) {
		sprintf(timestr, "%02d:%02d MDT", hr, mn);
		return (timestr);
	}
	if (hr >= 12)
		sprintf(timestr, "%2d:%02dpm", (hr > 12) ? hr - 12 : hr, mn);
	else
		if (hr > 0)
			sprintf(timestr, "%2d:%02dam", hr, mn);
		else
			sprintf(timestr, "12:%02dam", mn);

	return (timestr);
}
