/* Copyright (c) 1990 by Carrick Sean Casey. */
/* Modified 1991 by John Atwood deVries II. */
/* For copying and distribution information, see the file COPYING. */

/* This file contains routines that are unix dependent. */
/* Eventually, most unixisms should be moved here. */

#include "server.h"
#include "externs.h"
#include <sys/types.h>
#include <pwd.h>
#include <string.h>
#include <unistd.h>
#include <sys/dir.h>

#ifdef TERMIOS_H
#include <sys/termios.h>
#else
#include <sgtty.h>
#endif				/* TERMIOS_H */

#ifdef linux
#include <bsd/sgtty.h>
#endif				/* linux */

#ifdef hpux
#include <sys/bsdtty.h>
#endif				/* hpux */


#ifdef TERMIOS_H
struct termios origtty;
#else
struct sgtty origtty;		/* holds the user's original term settings */
#endif				/* TERMIOS_H */
int     badttyinfo = 0;		/* used when running under some weird modes */


/* set line buffering for an open file pointer */
/* output will be flushed every newline */
/* note: the following two funcs are only used in s_log.c --
         do they need to exist at all? */

void
linebuffer(fp)
	FILE   *fp;
{
/* XXX	setlinebuf(fp); */
	setvbuf(fp, (char *) NULL, _IOLBF, 0);
}

char   *
tildexpand(s)
	char   *s;
{
	struct passwd *pw;
	char    login[17];
	char   *p = login;
	static char path[MAXNAMLEN + 1];

	/* has to start with a tilde */
	if (*s++ != '~')
		return (s);

	/* skim off the login id */
	while (((*s >= 'A' && *s <= 'Z') || (*s >= 'a' && *s <= 'z') ||
		index(".-_", *s)) && ((p - login) < 17))
		*p++ = *s++;

	/* terminate string */
	*p = '\0';

	/* get home directory from password file */
	if ((pw = getpwnam(login)) == NULL)
		return (NULL);

	strcpy(path, pw->pw_dir);
	strcat(path, s);

	return (path);
}
